/*
   This file is provided under the LGPL license ver 2.1.
   Written by Katsumi
   http://hp.vector.co.jp/authors/VA016157/
*/

#include <xc.h>
#include "./api.h"

// 57272720 Hz (3632 * 15769 Hz)
#pragma config PMDL1WAY = OFF, IOL1WAY = OFF
#pragma config FPLLIDIV = DIV_1, FPLLMUL = MUL_16, FPLLODIV = DIV_1
#pragma config FNOSC = PRIPLL, FSOSCEN = OFF, POSCMOD = XT, OSCIOFNC = OFF
#pragma config FPBDIV = DIV_1, FWDTEN = OFF, JTAGEN = OFF, ICESEL = ICS_PGx1
#pragma config FCKSM = CSECMD

char cache[1024];

int beep=1;
int readpos=0;

int main(void){
	int i,j;
	FSFILE* fhandle;
	// Output to RB14
	TRISBCLR=0x4000;
	// Use CVrefout
	CVRCON=0x8040;
	// Use Timer 1 for 15769 Hz.
	PR1=3632;
	TMR1=0;
	IFS0bits.T1IF=0;
	T1CON=0x8000;
	// Timer1 interrupt: priority 4
	INTEnableSystemMultiVectoredInt();
	IPC1bits.T1IP=4;
	IPC1bits.T1IS=0;
	IEC0bits.T1IE=1;
//beep=440;
//while(1) asm("wait");
	// Start signal
	/*for(i=0;i<4;i++){
		beep=440;
		for(j=0;j<4000;j++) asm("wait");
		beep=880;
		for(j=0;j<4000;j++) asm("wait");
	}//*/
	// Open "mario.wav"
	beep=1;
	if(FSInit()==FALSE){
		beep=220;
		while(1) asm("wait");
	} else {
		fhandle=FSfopen("MARIO.WAV","r");
		if (!fhandle) {
			beep=440;
			while(1) asm("wait");
		}
	}
	FSfread(&cache[0],1,1024,fhandle);
	while(readpos<512){
		if (cache[readpos++]!='d') continue;
		if (cache[readpos++]!='a') continue;
		if (cache[readpos++]!='t') continue;
		if (cache[readpos++]!='a') continue;
		readpos+=4;
		break;
	}
	if (512<=readpos) {
		beep=880;
		while(1) asm("wait");
	}
	// Opened file sucessfully. Let's start music.
	beep=0;
	while(1) {
		while(readpos<512){
			asm("wait");
		}
		if (0==FSfread(&cache[0],1,512,fhandle)) break;
		while(readpos<1024){
			asm("wait");
		}
		readpos&=1024-1;
		if (0==FSfread(&cache[512],1,512,fhandle)) break;
	}
	beep=110;
	while(1) asm("wait");
}

#pragma interrupt timer1Int IPL4SOFT vector 4

void timer1Int(){
	char b;
	static counter=0;
	IFS0CLR=_IFS0_T1IF_MASK; //IFS0bits.T1IF=0;
	if (beep) {
		counter++;
		if (counter==(8000/beep)) {
			CVRCONCLR=0x000f;
		} else if ((16000/beep)<=counter) {
			CVRCONSET=0x000f;
			counter=0;
		}
	} else {
		b=cache[(readpos++)&(1024-1)];
		if (b<0x4e) b=0;
		else if (b<0x55) b=1;
		else if (b<0x5c) b=2;
		else if (b<0x63) b=3;
		else if (b<0x69) b=4;
		else if (b<0x70) b=5;
		else if (b<0x76) b=6;
		else if (b<0x7d) b=7;
		else if (b<0x83) b=8;
		else if (b<0x8a) b=9;
		else if (b<0x8f) b=10;
		else if (b<0x96) b=11;
		else if (b<0x9c) b=12;
		else if (b<0xa3) b=13;
		else if (b<0xa9) b=14;
		else b=15;
		CVRCON=CVRCON&0xfff0 | b;
	}
}
